/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __TYPEDEFS_H_
#define __TYPEDEFS_H_

typedef short PATH_TYPE;
typedef long long int INDEX_TYPE;
#define SUCCESSFUL_READ  0
#define INCOMPLETE_DATA  1

// Determine if the C++ compiler support the C++11 syntax and standard library
#if defined(__has_include)
	#if __has_include(<forward_list>)
		#define HAS_FORWARD_LIST 1
	#endif
#elif (__cplusplus >= 201103L) || (_MSC_VER >= 1800)
	#define HAS_FORWARD_LIST 1
#endif

#endif
