/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#include <iostream>
#include <stdlib.h>
#include <string>

using namespace std;

#ifndef MODEL_COMP_GRAPH_NODE
#define MODEL_COMP_GRAPH_NODE
class ModelCompGraphNode {

public:
	ModelCompGraphNode();
	~ModelCompGraphNode();

	friend ostream & operator <<(ostream &os, const ModelCompGraphNode &param);

public:
	string type;
	string name;
	bool PrivateOrJoin;
	int StateSize;
};

#endif
