/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __SOR_SOLVER_H_
#define __SOR_SOLVER_H_

#include "ISSSolver.h"

class SORSolver: public ISSSolver {
public:
	SORSolver(BaseStateLevel* _model, int argc, char** argv);

protected:
	virtual void compute_diagonal();
	virtual void perform_iteration();
	virtual void initialize_ds();
	virtual void terminate_ds();
};

#endif
