

// This C++ file was created by PEPAEditor

#include "Atomic/ConsumeWidgets/ConsumeWidgetsPEPA.h"

#include <stdlib.h>
#include <iostream>


/*****************************************************************
                         ConsumeWidgetsPEPA Constructor             
******************************************************************/


ConsumeWidgetsPEPA::ConsumeWidgetsPEPA(){


  PEPAActivity *InitialActionList[4] = {&outa_12isouta_22isouta, &outb, &recover, &fail};

  BaseGroupClass *InitialGroupList[4] = {
     (BaseGroupClass*) &(outa_12isouta_22isouta), 
     (BaseGroupClass*) &(outb), 
     (BaseGroupClass*) &(recover), 
     (BaseGroupClass*) &(fail)};

PEPAComponent0 = new PEPAVariable("PEPAComponent0", 0);

PEPAComponent0->appendAffectingAction(&outa_12isouta_22isouta);
PEPAComponent0->appendAffectingAction(&outb);
PEPAComponent0->appendEnabledAction(&outa_12isouta_22isouta);
PEPAComponent0->appendEnabledAction(&outb);

PEPAComponent1 = new PEPAVariable("PEPAComponent1", 0);

PEPAComponent1->appendAffectingAction(&outa_12isouta_22isouta);
PEPAComponent1->appendAffectingAction(&recover);
PEPAComponent1->appendAffectingAction(&fail);
PEPAComponent1->appendEnabledAction(&outa_12isouta_22isouta);
PEPAComponent1->appendEnabledAction(&recover);
PEPAComponent1->appendEnabledAction(&fail);

b = new PEPAVariable("b", 0);

b->appendAffectingAction(&outa_12isouta_22isouta);
b->appendAffectingAction(&outb);

a = new PEPAVariable("a", 0);

a->appendAffectingAction(&outa_12isouta_22isouta);
a->appendAffectingAction(&outb);


PEPAVariable *InitialVariables[4] = {PEPAComponent0, PEPAComponent1, b, a};

SetNumberOfComponents(2);

initializePEPAModelNow("ConsumeWidgets",
4, InitialVariables,
4, InitialActionList,
4, InitialGroupList);

outa_12isouta_22isouta.PEPAComponent0 = LocalStateVariables[0];
outa_12isouta_22isouta.PEPAComponent1 = LocalStateVariables[1];
outa_12isouta_22isouta.b = LocalStateVariables[2];
outa_12isouta_22isouta.a = LocalStateVariables[3];

outb.PEPAComponent0 = LocalStateVariables[0];
outb.b = LocalStateVariables[2];
outb.a = LocalStateVariables[3];

recover.PEPAComponent1 = LocalStateVariables[1];

fail.PEPAComponent1 = LocalStateVariables[1];

  outa_12isouta_22isouta.LinkVariables();
  outb.LinkVariables();
  recover.LinkVariables();
  fail.LinkVariables();

  outa_12isouta_22isouta.SetNumberOfComponents(2);
  outb.SetNumberOfComponents(1);
  recover.SetNumberOfComponents(1);
  fail.SetNumberOfComponents(1);

  outa_12isouta_22isouta.RegisterCompList(CompList);
  outb.RegisterCompList(CompList);
  recover.RegisterCompList(CompList);
  fail.RegisterCompList(CompList);

  outa_12isouta_22isouta.RegisterSuccessorState(0, 0);
  outa_12isouta_22isouta.RegisterSuccessorState(1, 0);
  outb.RegisterSuccessorState(0, 0);
  recover.RegisterSuccessorState(1, 0);
  fail.RegisterSuccessorState(1, 1);

  outa_12isouta_22isouta.RegisterEnabledInState(0, 0);
  outa_12isouta_22isouta.RegisterEnabledInState(1, 0);
  outb.RegisterEnabledInState(0, 0);
  recover.RegisterEnabledInState(1, 1);
  fail.RegisterEnabledInState(1, 0);

  outa_12isouta_22isouta.RegisterModel(this);
  outa_12isouta_22isouta.RegisterModel(this);
  outb.RegisterModel(this);
  recover.RegisterModel(this);
  fail.RegisterModel(this);

NumCanonGroups = 0;

}

/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::outa_12isouta_22isouta_Act() {
  TheDistributionParameters = new double[1];
  ActivityInitialize("outa_12isouta_22isouta", 0, Exponential, RaceEnabled, 4, 4, true);
}

void ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::LinkVariables() {
  addAffectedSV( PEPAComponent0);
  addAffectedSV( PEPAComponent1);
  addAffectedSV( a);
  addAffectedSV( b);

  addEnablingSV( PEPAComponent0);
  addEnablingSV( PEPAComponent1);
  addEnablingSV( a);
  addEnablingSV( b);

  PEPAComponent0->Register(&PEPAComponent0_Mobius_Value);
  PEPAComponent1->Register(&PEPAComponent1_Mobius_Value);
  b->Register(&b_Mobius_Value);
  a->Register(&a_Mobius_Value);
}

inline bool ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::GuardSatisfied() {
  return (((! (a->getValue() <= 0)) && 1) && 1);
}

BaseActionClass *ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::Fire() {
  UpdateCurrentTerms();
  a->setValue((a->getValue() - 1));
  b->setValue(b->getValue());
  return this;
}

double ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::Rate() {
  return ((ar_PEPALocal / (ar_PEPALocal + 0.0)) * ((inftyIdentifier_PEPALocal / (inftyIdentifier_PEPALocal + 0.0)) * min(((ar_PEPALocal + 0.0)),((inftyIdentifier_PEPALocal + 0.0)))));
  return 1.0;
}

double ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::SampleDistribution() {
  return TheDistribution->Exponential(((ar_PEPALocal / (ar_PEPALocal + 0.0)) * ((inftyIdentifier_PEPALocal / (inftyIdentifier_PEPALocal + 0.0)) * min(((ar_PEPALocal + 0.0)),((inftyIdentifier_PEPALocal + 0.0))))));
}

bool ConsumeWidgetsPEPA::outa_12isouta_22isouta_Act::OutputActivitiesDontClash() {
  return 1;

}

//=================================================================//

ConsumeWidgetsPEPA::outb_Act::outb_Act() {
  TheDistributionParameters = new double[1];
  ActivityInitialize("outb", 1, Exponential, RaceEnabled, 3, 3, true);
}

void ConsumeWidgetsPEPA::outb_Act::LinkVariables() {
  addAffectedSV( PEPAComponent0);
  addAffectedSV( a);
  addAffectedSV( b);

  addEnablingSV( PEPAComponent0);
  addEnablingSV( a);
  addEnablingSV( b);

  PEPAComponent0->Register(&PEPAComponent0_Mobius_Value);
  b->Register(&b_Mobius_Value);
  a->Register(&a_Mobius_Value);
}

inline bool ConsumeWidgetsPEPA::outb_Act::GuardSatisfied() {
  return (((! (b->getValue() <= 0)) && (a->getValue() == 0)) && 1);
}

BaseActionClass *ConsumeWidgetsPEPA::outb_Act::Fire() {
  UpdateCurrentTerms();
  a->setValue(a->getValue());
  b->setValue((b->getValue() - 1));
  return this;
}

double ConsumeWidgetsPEPA::outb_Act::Rate() {
  return br_PEPALocal;
  return 1.0;
}

double ConsumeWidgetsPEPA::outb_Act::SampleDistribution() {
  return TheDistribution->Exponential(br_PEPALocal);
}

bool ConsumeWidgetsPEPA::outb_Act::OutputActivitiesDontClash() {
  return 1;

}

//=================================================================//

ConsumeWidgetsPEPA::recover_Act::recover_Act() {
  TheDistributionParameters = new double[1];
  ActivityInitialize("recover", 2, Exponential, RaceEnabled, 1, 1, true);
}

void ConsumeWidgetsPEPA::recover_Act::LinkVariables() {
  addAffectedSV( PEPAComponent1);

  addEnablingSV( PEPAComponent1);

  PEPAComponent1->Register(&PEPAComponent1_Mobius_Value);
}

inline bool ConsumeWidgetsPEPA::recover_Act::GuardSatisfied() {
  return 1;
}

BaseActionClass *ConsumeWidgetsPEPA::recover_Act::Fire() {
  UpdateCurrentTerms();
  return this;
}

double ConsumeWidgetsPEPA::recover_Act::Rate() {
  return RecoverRate;
  return 1.0;
}

double ConsumeWidgetsPEPA::recover_Act::SampleDistribution() {
  return TheDistribution->Exponential(RecoverRate);
}

bool ConsumeWidgetsPEPA::recover_Act::OutputActivitiesDontClash() {
  return 1;

}

//=================================================================//

ConsumeWidgetsPEPA::fail_Act::fail_Act() {
  TheDistributionParameters = new double[1];
  ActivityInitialize("fail", 3, Exponential, RaceEnabled, 1, 1, true);
}

void ConsumeWidgetsPEPA::fail_Act::LinkVariables() {
  addAffectedSV( PEPAComponent1);

  addEnablingSV( PEPAComponent1);

  PEPAComponent1->Register(&PEPAComponent1_Mobius_Value);
}

inline bool ConsumeWidgetsPEPA::fail_Act::GuardSatisfied() {
  return 1;
}

BaseActionClass *ConsumeWidgetsPEPA::fail_Act::Fire() {
  UpdateCurrentTerms();
  return this;
}

double ConsumeWidgetsPEPA::fail_Act::Rate() {
  return fr_PEPALocal;
  return 1.0;
}

double ConsumeWidgetsPEPA::fail_Act::SampleDistribution() {
  return TheDistribution->Exponential(fr_PEPALocal);
}

bool ConsumeWidgetsPEPA::fail_Act::OutputActivitiesDontClash() {
  return 1;

}

