#ifndef SystemRJ_H_
#define SystemRJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/System/SystemRJ__Robots.h"
#include "Atomic/ConsumeWidgets/ConsumeWidgetsPEPA.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/PEPA/PEPAVariable.h"

class SystemRJ: public Join {
 public:
  SystemRJ__Robots * Robots;
  ConsumeWidgetsPEPA * Consume;
  Place * FirstBin;
  Place * SecondBin;

  SystemRJ();
  ~SystemRJ();
};

#endif
