#ifndef _AVNUMINBINS_PVS_
#define _AVNUMINBINS_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/System/SystemRJ__Robots.h"
#include "Composed/System/SystemRJ.h"
#include "Cpp/Performance_Variables/SteadyState.hpp"


class AvNumInBinsPV0Worker:public SteadyState
{
 public:
  ConsumeWidgetsPEPA *Consume;
  
  AvNumInBinsPV0Worker();
  ~AvNumInBinsPV0Worker();
  double Reward_Function();
};

class AvNumInBinsPV0:public PerformanceVariableNode
{
 public:
  SystemRJ *TheSystemRJ;

  AvNumInBinsPV0Worker *AvNumInBinsPV0WorkerList;

  AvNumInBinsPV0(int timeindex=0);
  ~AvNumInBinsPV0();
  void CreateWorkerList(void);
};

class AvNumInBinsPV1Worker:public SteadyState
{
 public:
  ConsumeWidgetsPEPA *Consume;
  
  AvNumInBinsPV1Worker();
  ~AvNumInBinsPV1Worker();
  double Reward_Function();
};

class AvNumInBinsPV1:public PerformanceVariableNode
{
 public:
  SystemRJ *TheSystemRJ;

  AvNumInBinsPV1Worker *AvNumInBinsPV1WorkerList;

  AvNumInBinsPV1(int timeindex=0);
  ~AvNumInBinsPV1();
  void CreateWorkerList(void);
};

#endif
