#include "multi_proc_PVPVModel.h"

multi_proc_PVPVModel::multi_proc_PVPVModel(bool expandTimeArrays) {
  TheModel=new multi_procRJ();
  DefineName("multi_proc_PVPVModel");
  StateMode = 1;
  CreatePVList(1, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* multi_proc_PVPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new multi_proc_PVPV0(timeindex);
    break;
  }
  return NULL;
}
