#include "Composed/database2/database2RJ.h"
char * database2RJ__SharedNames[] = {"system_fail"};

database2RJ::database2RJ():Join("Join2", 2, 1,database2RJ__SharedNames) {
  Rep2 = new database2RJ__Rep2();
  ModelArray[0] = (BaseModelClass*) Rep2;
  ModelArray[0]->DefineName("Rep2");
  processors = new processorsSAN();
  ModelArray[1] = (BaseModelClass*) processors;
  ModelArray[1]->DefineName("processors");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    system_fail = new Place("system_fail");
    addSharedPtr(system_fail, "system_fail" );
    if (Rep2->NumStateVariables > 0) {
      system_fail->ShareWith(Rep2->system_fail);
      addSharingInfo(Rep2->system_fail, system_fail, Rep2);
    }
    if (processors->NumStateVariables > 0) {
      system_fail->ShareWith(processors->system_fail);
      addSharingInfo(processors->system_fail, system_fail, processors);
    }

  }

  Setup();
}

database2RJ::~database2RJ() {
  if (!AllChildrenEmpty()) {
    delete system_fail;
  }
  delete Rep2;
  delete processors;
}
