#include "database_a_PVPVNodes.h"

database_a_PVPV0Worker::database_a_PVPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&processors);
}

database_a_PVPV0Worker::~database_a_PVPV0Worker() {
  delete [] TheModelPtr;
}

double database_a_PVPV0Worker::Reward_Function(void) {

double reward = 0;
if (processors->system_fail->Mark() == 0)
     {
        reward += 1.0;
     }
return (reward);

return (0);



}

database_a_PVPV0::database_a_PVPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&Thedatabase2RJ);
  double startpts[1]={10.0};
  double stoppts[1]={10.0};
  Initialize("availability",(RewardType)0,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("system_fail","processors");
}

database_a_PVPV0::~database_a_PVPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void database_a_PVPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new database_a_PVPV0Worker;
}
