#ifndef _DATABASE_A_PV_PVS_
#define _DATABASE_A_PV_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/database2/database2RJ__Rep2.h"
#include "Composed/database2/database2RJ__Rep1.h"
#include "Composed/database2/database2RJ.h"
#include "Composed/database2/database2RJ__Join1.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class database_a_PVPV0Worker:public InstantOfTime
{
 public:
  processorsSAN *processors;
  
  database_a_PVPV0Worker();
  ~database_a_PVPV0Worker();
  double Reward_Function();
};

class database_a_PVPV0:public PerformanceVariableNode
{
 public:
  database2RJ *Thedatabase2RJ;

  database_a_PVPV0Worker *database_a_PVPV0WorkerList;

  database_a_PVPV0(int timeindex=0);
  ~database_a_PVPV0();
  void CreateWorkerList(void);
};

#endif
