
#ifndef availabilityRangeSTUDY_H_
#define availabilityRangeSTUDY_H_

#include "Reward/database_a_PV/database_a_PVPVNodes.h"
#include "Reward/database_a_PV/database_a_PVPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern double repair_rate;

class availabilityRangeStudy : public BaseStudyClass {
public:

availabilityRangeStudy();
~availabilityRangeStudy();

private:

double *repair_rateValues;

void SetValues_repair_rate();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

