

// This C++ file was created by SanEditor

#include "Atomic/bus/busSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         busSAN Constructor             
******************************************************************/


busSAN::busSAN(){


  Activity* InitialActionList[1]={
    &Ac_prop_delay  // 0
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(Ac_prop_delay)
  };

  channel = new Place("channel" ,0);
  BaseStateVariableClass* InitialPlaces[1]={
    channel   // 0
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("bus", 1, InitialPlaces, 
                        0, InitialROPlaces, 
                        1, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[1][2]={ 
    {0,0}
  };
  for(int n=0;n<1;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[1][2]={ 
    {0,0}
  };
  for(int n=0;n<1;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<1;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void busSAN::CustomInitialization() {

}
busSAN::~busSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void busSAN::assignPlacesToActivitiesInst(){
}
void busSAN::assignPlacesToActivitiesTimed(){
  Ac_prop_delay.channel = (Place*) LocalStateVariables[0];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Ac_prop_delayActivity========================*/

busSAN::Ac_prop_delayActivity::Ac_prop_delayActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Ac_prop_delay",0,Exponential, RaceEnabled, 1,1, false);
}

busSAN::Ac_prop_delayActivity::~Ac_prop_delayActivity(){
  delete[] TheDistributionParameters;
}

void busSAN::Ac_prop_delayActivity::LinkVariables(){
  channel->Register(&channel_Mobius_Mark);
}

bool busSAN::Ac_prop_delayActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=((channel->Mark()==1));
  return NewEnabled;
}

double busSAN::Ac_prop_delayActivity::Rate(){
  return 20;
  return 1.0;  // default rate if none is specified
}

double busSAN::Ac_prop_delayActivity::Weight(){ 
  return 1;
}

bool busSAN::Ac_prop_delayActivity::ReactivationPredicate(){ 
  return false;
}

bool busSAN::Ac_prop_delayActivity::ReactivationFunction(){ 
  return false;
}

double busSAN::Ac_prop_delayActivity::SampleDistribution(){
  return TheDistribution->Exponential(20);
}

double* busSAN::Ac_prop_delayActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int busSAN::Ac_prop_delayActivity::Rank(){
  return 1;
}

BaseActionClass* busSAN::Ac_prop_delayActivity::Fire(){
  channel->Mark()=2;
  return this;
}

