#include "Composed/lan2/lan2RJ.h"
char * lan2RJ__SharedNames[] = {"channel"};

lan2RJ::lan2RJ():Join("Join1", 2, 1,lan2RJ__SharedNames) {
  Rep1 = new lan2RJ__Rep1();
  ModelArray[0] = (BaseModelClass*) Rep1;
  ModelArray[0]->DefineName("Rep1");
  bus = new busSAN();
  ModelArray[1] = (BaseModelClass*) bus;
  ModelArray[1]->DefineName("bus");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    channel = new Place("channel");
    addSharedPtr(channel, "channel" );
    if (Rep1->NumStateVariables > 0) {
      channel->ShareWith(Rep1->channel);
      addSharingInfo(Rep1->channel, channel, Rep1);
    }
    if (bus->NumStateVariables > 0) {
      channel->ShareWith(bus->channel);
      addSharingInfo(bus->channel, channel, bus);
    }

  }

  Setup();
}

lan2RJ::~lan2RJ() {
  if (!AllChildrenEmpty()) {
    delete channel;
  }
  delete Rep1;
  delete bus;
}
