#ifndef lan2RJ_H_
#define lan2RJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/lan2/lan2RJ__Rep1.h"
#include "Atomic/bus/busSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class lan2RJ: public Join {
 public:
  lan2RJ__Rep1 * Rep1;
  busSAN * bus;
  Place * channel;

  lan2RJ();
  ~lan2RJ();
};

#endif
