/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: MobiusTypeDefs.h
 *
 *      Authors: Jay M. Doyle, Daniel D. Deavours, William H. Sanders
 *      Creation Date: 1999
 *
 *      Copyright (c) 1994-2008 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef MOBIUS_TYPE_DEF_H_
#define MOBIUS_TYPE_DEF_H_

/** These specific typedefs for mobius base classes
 * @author Jay M. Doyle
 * @version Mobius Version 1.0
 */

/** A typedef for  char*
 */
typedef char* String;

/**
 * A typedef for a type of size 1
 * That is its one byte
 */
typedef unsigned char byte;

#endif
