/*****************************************************************************\
 *                            RESTRICTED RIGHTS LEGEND
 *
 *      Use, duplication, or disclosure by the Government is subject to
 *      restrictions as set forth in subparagraph (c) (1) (ii) of the Rights in
 *      Technical Data and Computer Software Clause at DFARS 252.227-7013.
 *
 *      The Board of Trustees of the University of Illinois
 *      109 Coble Hall
 *      801 South Wright Street
 *      Champaign, IL 61820-6242
 *
 *      File: misc.h
 *
 *      Authors: S. Derisavi, William H. Sanders
 *      Creation Date: 2004
 *
 *      Copyright (c) 1994-2004 William H. Sanders, and
 *      The Board of Trustees of the University of Illinois
 *      All rights reserved.
 *
 \*****************************************************************************/

#ifndef __MISC_H_
#define __MISC_H_

#include <getopt.h>

#ifdef  __cplusplus
extern "C" {
#endif

#if defined (MOBIUS_SOLARIS) | defined (MINGW)
char* strsep(char** stringp, const char *delim);
#endif

//Declaration I got from getopt manpage (derisavi 9/9/04)
int mobius_getopt(int argc, char* const argv[], const char* options);

#ifdef  __cplusplus
}

#endif

#endif
