/*
 * PAddress.h
 *
 *  Created on: Jul 26, 2012
 *      Author: kjkeefe
 */

#ifndef PADDRESS_H_
#define PADDRESS_H_

#include <cstddef>
#include <list>

class Event;
class BaseActionClass;

class PAddress {
public:
	PAddress() {
		clear();
	}
	void clear() {
		event = nullptr;
		reactIsNull = true;
	}
	bool isReactNull() {
		return reactIsNull;
	}
	std::list<BaseActionClass*>::iterator getReact() {
		return react;
	}
	void setReact(std::list<BaseActionClass*>::iterator iter) {
		reactIsNull = false;
		react = iter;
	}
	void setReactNull() {
		reactIsNull = true;
	}

	Event **event;

private:
	bool reactIsNull;
	std::list<BaseActionClass*>::iterator react;
};

#endif /* PADDRESS_H_ */
