#ifndef SystemRJ__Robots_H_
#define SystemRJ__Robots_H_
#include <math.h>
#include "Cpp/Composer/Rep.h"
#include "Cpp/Composer/AllStateVariableTypes.h"

//Submodel header files
#include "Atomic/RobotArm/RobotArmSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class SystemRJ__Robots: public Rep {
 public:
  RobotArmSAN ** InstanceArray;

  SystemRJ__Robots();
  ~SystemRJ__Robots();

  // Declare new variables
  Place * Bin;
  Place * Bin2;
};

#endif
