#include "AvNumInBinsPVModel.h"

AvNumInBinsPVModel::AvNumInBinsPVModel(bool expandTimeArrays) {
  TheModel=new SystemRJ();
  DefineName("AvNumInBinsPVModel");
  CreatePVList(2, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* AvNumInBinsPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new AvNumInBinsPV0(timeindex);
    break;
  case 1:
    return new AvNumInBinsPV1(timeindex);
    break;
  }
  return NULL;
}
