
#ifndef AvNumStudyRangeSTUDY_H_
#define AvNumStudyRangeSTUDY_H_

#include "Reward/AvNumInBins/AvNumInBinsPVNodes.h"
#include "Reward/AvNumInBins/AvNumInBinsPVModel.h"
#include "Cpp/Study/BaseStudyClass.hpp"

extern short ACCMINTOASSEMBLE;
extern short ACCSIZE;
extern short BINSIZE;
extern double RecoverRate;

class AvNumStudyRangeStudy : public BaseStudyClass {
public:

AvNumStudyRangeStudy();
~AvNumStudyRangeStudy();

private:

short *ACCMINTOASSEMBLEValues;
short *ACCSIZEValues;
short *BINSIZEValues;
double *RecoverRateValues;

void SetValues_ACCMINTOASSEMBLE();
void SetValues_ACCSIZE();
void SetValues_BINSIZE();
void SetValues_RecoverRate();

void PrintGlobalValues(int);
void *GetGVValue(char *TheGVName);
void OverrideGVValue(char *TheGVName, void *TheGVValue);
void SetGVs(int expnum);
PVModel *GetPVModel(bool expandTimeArrays);
};

#endif

