#ifndef _MULTIPROC_PV_PVS_
#define _MULTIPROC_PV_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Composed/multi_proc/multi_procRJ.h"
#include "Composed/multi_proc/multi_procRJ__Memory.h"
#include "Composed/multi_proc/multi_procRJ__Computer.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"


class MultiProc_PVPV0Worker:public InstantOfTime
{
 public:
  cpu_moduleSAN *cpu_module;
  
  MultiProc_PVPV0Worker();
  ~MultiProc_PVPV0Worker();
  double Reward_Function();
};

class MultiProc_PVPV0:public PerformanceVariableNode
{
 public:
  multi_procRJ *Themulti_procRJ;

  MultiProc_PVPV0Worker *MultiProc_PVPV0WorkerList;

  MultiProc_PVPV0(int timeindex=0);
  ~MultiProc_PVPV0();
  void CreateWorkerList(void);
};

#endif
