#include "Composed/multi_proc/multi_procRJ.h"
char * multi_procRJ__SharedNames[] = {};

multi_procRJ::multi_procRJ():Rep("REP2", num_comp, 0, multi_procRJ__SharedNames)
{
  InstanceArray = new multi_procRJ__JOIN1 * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new multi_procRJ__JOIN1();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  Setup("JOIN1");
}

multi_procRJ::~multi_procRJ() {
  if (NumModels == 0) return;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

