#ifndef multi_procRJ__JOIN1_H_
#define multi_procRJ__JOIN1_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/multi_proc/multi_procRJ__REP1.h"
#include "Atomic/cpu_module/cpu_moduleSAN.h"
#include "Atomic/errorhandlers/errorhandlersSAN.h"
#include "Atomic/io_port_module/io_port_moduleSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"
extern short num_mem_mod;

class multi_procRJ__JOIN1: public Join {
 public:
  multi_procRJ__REP1 * REP1;
  cpu_moduleSAN * cpu_module;
  errorhandlersSAN * errorhandler;
  io_port_moduleSAN * io_port_module;
  Place * computer_failed;
  Place * cpus;
  Place * errorhandlers;
  Place * ioports;
  Place * memory_failed;

  multi_procRJ__JOIN1();
  ~multi_procRJ__JOIN1();
};

#endif
