#ifndef database2RJ_H_
#define database2RJ_H_
#include <math.h>
#include "Cpp/Composer/Join.h"
#include "Cpp/Composer/AllStateVariableTypes.h"
#include "Composed/database2/database2RJ__Rep2.h"
#include "Atomic/processors/processorsSAN.h"

//State variable headers
#include "Cpp/BaseClasses/SAN/Place.h"

class database2RJ: public Join {
 public:
  database2RJ__Rep2 * Rep2;
  processorsSAN * processors;
  Place * system_fail;

  database2RJ();
  ~database2RJ();
};

#endif
