#include "Composed/database2/database2RJ__Join1.h"
char * database2RJ__Join1__SharedNames[] = {"system_fail"};

database2RJ__Join1::database2RJ__Join1():Join("Join1", 2, 1,database2RJ__Join1__SharedNames) {
  Rep1 = new database2RJ__Rep1();
  ModelArray[0] = (BaseModelClass*) Rep1;
  ModelArray[0]->DefineName("Rep1");
  controllers = new controllersSAN();
  ModelArray[1] = (BaseModelClass*) controllers;
  ModelArray[1]->DefineName("controllers");

  SetupActions();
  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************  State sharing info  **************
    //Shared variable 0
    system_fail = new Place("system_fail");
    addSharedPtr(system_fail, "system_fail" );
    if (Rep1->NumStateVariables > 0) {
      system_fail->ShareWith(Rep1->system_fail);
      addSharingInfo(Rep1->system_fail, system_fail, Rep1);
    }
    if (controllers->NumStateVariables > 0) {
      system_fail->ShareWith(controllers->system_fail);
      addSharingInfo(controllers->system_fail, system_fail, controllers);
    }

  }

  Setup();
}

database2RJ__Join1::~database2RJ__Join1() {
  if (!AllChildrenEmpty()) {
    delete system_fail;
  }
  delete Rep1;
  delete controllers;
}
