#include "Composed/database2/database2RJ__Rep1.h"
char * database2RJ__Rep1__SharedNames[] = {"system_fail"};

database2RJ__Rep1::database2RJ__Rep1():Rep("Rep1", 3, 1, database2RJ__Rep1__SharedNames)
{
  InstanceArray = new disksSAN * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new disksSAN();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    system_fail = new Place("system_fail");
    addSharedPtr(system_fail, "system_fail");
    system_fail->ShareWith(InstanceArray[0]->system_fail);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->system_fail, system_fail);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->system_fail->ShareWith(InstanceArray[counter]->system_fail);
    }
  }
  Setup("disks");
}

database2RJ__Rep1::~database2RJ__Rep1() {
  if (NumModels == 0) return;
  delete system_fail;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

