#include "Composed/database2/database2RJ__Rep2.h"
char * database2RJ__Rep2__SharedNames[] = {"system_fail"};

database2RJ__Rep2::database2RJ__Rep2():Rep("Rep2", 2, 1, database2RJ__Rep2__SharedNames)
{
  InstanceArray = new database2RJ__Join1 * [NumModels];
  delete[] ModelArray;
  ModelArray = (BaseModelClass **) InstanceArray;
  for (counter = 0; counter < NumModels; counter++)
    InstanceArray[counter] = new database2RJ__Join1();

  SetupActions();
  if (NumModels == 0) return;

  if (AllChildrenEmpty())
    NumSharedStateVariables = 0;
  else {
    //**************** Initialize local variables ****************
    system_fail = new Place("system_fail");
    addSharedPtr(system_fail, "system_fail");
    system_fail->ShareWith(InstanceArray[0]->system_fail);


    //Share state in submodels
    for (counter = 0; counter < NumModels; counter++) {
      addSharingInfo(InstanceArray[counter]->system_fail, system_fail);
    }
    for (counter = 1; counter < NumModels; counter++) {
      InstanceArray[0]->system_fail->ShareWith(InstanceArray[counter]->system_fail);
    }
  }
  Setup("Join1");
}

database2RJ__Rep2::~database2RJ__Rep2() {
  if (NumModels == 0) return;
  delete system_fail;
  for (int i = 0; i < NumModels; i++)
    delete InstanceArray[i];
}

