#include "lan_rewardPVModel.h"

lan_rewardPVModel::lan_rewardPVModel(bool expandTimeArrays) {
  TheModel=new lan2RJ();
  DefineName("lan_rewardPVModel");
  CreatePVList(5, expandTimeArrays);
  Initialize();
}



PerformanceVariableNode* lan_rewardPVModel::createPVNode(int pvindex, int timeindex) {
  switch(pvindex) {
  case 0:
    return new lan_rewardPV0(timeindex);
    break;
  case 1:
    return new lan_rewardPV1(timeindex);
    break;
  case 2:
    return new lan_rewardPV2(timeindex);
    break;
  case 3:
    return new lan_rewardPV3(timeindex);
    break;
  case 4:
    return new lan_rewardPV4(timeindex);
    break;
  }
  return NULL;
}
